import marked from 'marked';
import prism from 'prismjs';
import 'prismjs/components/prism-sass';
import 'prismjs/components/prism-typescript';
export class Markdown {
    componentWillLoad() {
        this.renderMarkup();
    }
    componentWillUpdate() {
        this.renderMarkup();
    }
    renderMarkup() {
        this.element.innerHTML = marked(this.precompile(this.data));
        prism.highlightAll(false);
    }
    precompile(markdown) {
        if (!markdown) {
            return '';
        }
        let indentStart;
        return markdown
            .replace(/\&gt;/g, '>')
            .split('\n')
            .map(line => {
            // find position of 1st non-whitespace character
            // to determine the markdown indentation start
            if (line.length > 0 && isNaN(indentStart)) {
                indentStart = line.search(/\S|$/);
            }
            // remove whitespaces before indentation start
            return indentStart
                ? line.substring(indentStart)
                : line;
        }).join('\n');
    }
    static get is() { return "ajd-markdown"; }
    static get properties() { return {
        "data": {
            "type": String,
            "attr": "data"
        },
        "element": {
            "elementRef": true
        }
    }; }
    static get style() { return "/**style-placeholder:ajd-markdown:**/"; }
}
